#! /usr/bin/env python
#  -*- coding: utf-8 -*-
#
# Support module generated by PAGE version 5.0.2
#  in conjunction with Tcl version 8.6
#    Jun 09, 2020 11:49:30 PM CEST  platform: Windows NT

from tkinter import *
import sys
import requests
import matplotlib
matplotlib.use("TkAgg")
from matplotlib.backends.backend_tkagg import *
#FigureCanvasTkAgg, NavigationToolbar2TkAgg

from matplotlib.figure import Figure
from matplotlib.backends.backend_tkagg import (
    FigureCanvasTkAgg, NavigationToolbar2Tk)
import numpy as np

import matplotlib.pyplot as plot

try:
    import Tkinter as tk
except ImportError:
    import tkinter as tk

try:
    import ttk
    py3 = False
except ImportError:
    import tkinter.ttk as ttk
    py3 = True

def init(top, gui, *args, **kwargs):
    global w, top_level, root
    w = gui
    top_level = top
    root = top

def DefaultButPressed():
    global w,root

    w.LatTB.delete('0.0',tk.END)
    w.LongTB.delete('0.0',tk.END)
    w.LatTB.insert('0.0',"58.5812")
    w.LongTB.insert('0.0',"16.158")
    sys.stdout.flush()

def SubmitLatLong():
    global w,top
    latitude=w.LatTB.get('0.0',tk.END)
    longitude=w.LongTB.get('0.0',tk.END)
    reqstr="https://opendata-download-metfcst.smhi.se/api/category/" \
           "pmp3g/version/2/geotype/point/lon/"+longitude[:-1] + \
           "/lat/" + latitude[:-1] + "/data.json"

    resp = requests.get(reqstr)

    temp=([])
    N=0

    w.TemperatureLB.delete(0,tk.END)
    for timeser in resp.json()["timeSeries"]:
        for param in timeser["parameters"]:
            #Only get the first 36 hours. The other data do not come every hour
           if param["name"]=="t" and N<40 :
               #Debug write to console
               #print('{} {} {}'.format(timeser["validTime"], param["name"], param["values"]))
               tempLBstr=str(timeser["validTime"]) + " " + str(param["values"])
               w.TemperatureLB.insert(tk.END,tempLBstr)
               temp=temp+param["values"]
               N=N+1
    print(temp)
    scrollbar = Scrollbar(w.TemperatureLB, orient="vertical")
    scrollbar.config(command=w.TemperatureLB.yview)
    scrollbar.pack(side="right", fill="y")
    w.TemperatureLB.config(yscrollcommand=scrollbar.set)

    x=np.arange(N)
    f = Figure(figsize=(5,5), dpi=100)
    P1 = f.add_subplot(111)

    x=np.arange(N)
    P1.plot(x,temp)
    P1.bottom=0,200
    P1.left=0,3
    P1.set_ylabel('Temp in C')
    P1.set_xlabel('Hours from now:' )
    P1.set_title('Temperature in the selected area')


    ind = np.arange(N)    # the x locations for the groups

    #P1.set_xticks(ind, ())
    #P1.set_xticks(np.arange(0, N, 10))
    #('G1', 'G2', 'G3', 'G4', 'G5'))
    #P1.set_yticks(np.arange(0, 41, 10))

    w.Canvas1 = FigureCanvasTkAgg(f, w.Canvas1)
    w.Canvas1.draw()
    w.Canvas1.get_tk_widget().pack(side=tk.BOTTOM, fill=tk.BOTH, expand=True)

    toolbar = NavigationToolbar2Tk(w.Canvas1,root)

    P1.set_aspect(0.9)

def destroy_window():
    # Function which closes the window.
    global top_level
    top_level.destroy()
    top_level = None

if __name__ == '__main__':
    import SMHI_JSON_GUI_window
    SMHI_JSON_GUI_window.vp_start_gui()
